package com.bergerkiller.bukkit.nolagg;

import java.io.DataOutputStream;
import java.io.IOException;
import java.lang.reflect.Field;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.logging.Level;

import net.minecraft.server.Packet;
import net.minecraft.server.Packet51MapChunk;

@SuppressWarnings({ "rawtypes", "unchecked" })
public class BufferedPacket51MapChunk extends Packet51MapChunk {
	
	public static String getBufferSizeName() {
		int size = 80 * buffers.size();
		if (size < 1000) {
			return size + " kb";
		} else {
			return ((double) size / 1000) + " mb";
		}
	}
	
	private static List<Integer> freeIndices = new ArrayList<Integer>();
	private static List<byte[]> buffers = new ArrayList<byte[]>();
	
	private final int bufferindex;
	public BufferedPacket51MapChunk(net.minecraft.server.Chunk chunk) {
		synchronized (buffers) {
			if (freeIndices.isEmpty()) {
				this.bufferindex = buffers.size();
				buffers.add(this.rawData = new byte[81920]);
			} else {
				this.bufferindex = freeIndices.remove(0);
				this.rawData = buffers.get(this.bufferindex);
			}
		}
        System.arraycopy(chunk.b, 0, this.rawData, 0, 32768);
        System.arraycopy(chunk.g.a, 0, this.rawData, 32768, 16384);
        System.arraycopy(chunk.i.a, 0, this.rawData, 49152, 16384);
        System.arraycopy(chunk.h.a, 0, this.rawData, 65536, 16384);
        this.a = chunk.x << 4;
        this.c = chunk.z << 4;
        this.d = 16;
        this.e = 128;
        this.f = 16;
	}
	
	public void a(DataOutputStream dataoutputstream) throws IOException {
		super.a(dataoutputstream);
		synchronized (buffers) {
			freeIndices.add(this.bufferindex);
		}
	}
		
	static {
		try {
			Field a = Packet.class.getDeclaredField("a");
			a.setAccessible(true);
			Map map = (Map) a.get(null);
			map.put(BufferedPacket51MapChunk.class, 51);
		} catch (Exception e) {
			NoLagg.log(Level.SEVERE, "Failed to bind to map packet chunk, total failure imminent!");
			e.printStackTrace();
		}
	}
}
