package com.bergerkiller.bukkit.nolagg;

import java.util.logging.Level;

import net.minecraft.server.Chunk;
import net.minecraft.server.ChunkProviderServer;
import net.minecraft.server.WorldServer;

import org.bukkit.event.world.ChunkUnloadEvent;
import org.bukkit.event.world.WorldListener;

import com.bergerkiller.bukkit.nolagg.ChunkOperation.Type;
import com.bergerkiller.bukkit.nolagg.meta.WorldMetaData;

public class NLUnloadListener extends WorldListener {
	
	public static long unloadedChunks = 0;
	
	/*
	 * This function takes over the world unloading bit
	 * It unloads chunks the same way native unloading works
	 * Difference is that saving is done in a separate thread ;)
	 */
	public void onChunkUnload(ChunkUnloadEvent event) {
		if (!event.isCancelled()) {
			Chunk chunk = ChunkHandler.getNative(event.getChunk());
			try {
				chunk.removeEntities();
				ChunkProviderServer cps = ((WorldServer) chunk.world).chunkProviderServer;
				long coord = Util.toLong(chunk.x, chunk.z);
				cps.chunks.remove(coord);
				cps.chunkList.remove(chunk);
				cps.unloadQueue.remove(coord);
				ChunkScheduler.schedule(chunk, Type.UNLOAD);
				event.setCancelled(true);
			} catch (Throwable t) {
				NoLagg.log(Level.SEVERE, "Failed to unload chunk [" + chunk.x + "/" + chunk.z + "/" + chunk.world.getWorld().getName() + "]:");
				t.printStackTrace();
			}
			WorldMetaData.get(event.getWorld()).removeChunk(chunk.x, chunk.z);
			unloadedChunks++;
			
			/*
			 * This is executed after this event; it's what we now cancel and which needs to be done at some point!
			 * 
            chunk.removeEntities();
            this.saveChunk(chunk);
            this.saveChunkNOP(chunk);
            // this.unloadQueue.remove(integer);
            this.chunks.remove(chunkcoordinates); // CraftBukkit
            this.chunkList.remove(chunk);
			*/
		}
	}

}
